Device = 18F25K20    'Automatically brings in device file 18F25K22.bas
Clock = 64           '64MHz (top speed)
Config FOSC = HSPLL   'tells PIC to use external high speed (crystal) oscillator, medium power

'Libraries                                                               
Include "utils.bas"      // we are including an extra file here which allows us to use shortcuts    
Include "RandGen.bas" 

' Arrays
Dim OutputDataRed(16) As LongWord 
Dim OutputDataGreen(16) As LongWord
Dim OutputDataBlue(16) As LongWord

' Variables
Dim x As Word
Dim y As Byte
Dim AnimationDelay As Byte
Dim TempData0 As LongWord  
Dim TempData1 As LongWord
Dim TempData2 As LongWord
Dim TempData3 As LongWord
Dim TempData4 As LongWord
Dim TempData5 As LongWord

' Port Pins
Dim RedData0 As PORTB.0
Dim RedData1 As PORTB.1
Dim GreenData0 As PORTB.4
Dim GreenData1 As PORTB.5
Dim BlueData0 As PORTB.2
Dim BlueData1 As PORTB.3
Dim RowA As PORTC.1
Dim RowB As PORTC.2 
Dim RowC As PORTC.3
Dim Latch As PORTB.6
Dim CLK As PORTB.7
Dim OutputEnable As PORTC.4

' Sub Routines
Sub DrawGraphics() ' All we need to do is store 32 long words in our output data registers, and this routine will take care of displaying them on the screen!
    For y = 0 To 7
        TempData0 = OutputDataRed(y)
        TempData1 = OutputDataRed(y + 8)       
        TempData2 = OutputDataGreen(y)
        TempData3 = OutputDataGreen(y + 8) 
        TempData4 = OutputDataBlue(y)
        TempData5 = OutputDataBlue(y + 8)
        For x = 0 To 31
            RedData0 = TempData0.bits(31 - x)
            RedData1 = TempData1.bits(31 - x) 
            GreenData0 = TempData2.bits(31 - x)
            GreenData1 = TempData3.bits(31 - x) 
            BlueData0 = TempData4.bits(31 - x)
            BlueData1 = TempData5.bits(31 - x)
            CLK = 1
            CLK = 0
        Next
        RowA = y.bits(0)
        RowB = y.bits(1)
        RowC = y.bits(2)
        Latch = 1
        Latch = 0  
        OutputEnable = 0
        DelayUS(250)
        OutputEnable = 1
    Next           
End Sub

Sub DrawFillBox(FromX As Byte, FromY As Byte, ToX As Byte, ToY As Byte, Color As Byte)
        Dim Temp As Byte
        If FromY > ToY Then
            Temp = FromY
            FromY = ToY
            ToY = Temp
        EndIf
        If FromX > ToX Then
            Temp = FromX
            FromX = ToX
            ToX = Temp
        EndIf
        If Color = 0 Then 
            Color = 1
        EndIf
        For x = 0 To (ToY - FromY)
            For y = 0 To (ToX - FromX)
                OutputDataRed(FromX + y).bits(FromY + x) = Color.bits(0)
                OutputDataGreen(FromX + y).bits(FromY + x) = Color.bits(1)
                OutputDataBlue(FromX + y).bits(FromY + x) = Color.bits(2)
            Next
        Next   
End Sub

Sub MakeBoxes()
    If AnimationDelay <> 0 Then
        Dec(AnimationDelay)
    Else
        AnimationDelay = 5
        DrawFillBox((Rand()/16),(Rand()/8),(Rand()/16),(Rand()/8),(Rand()/32))
    EndIf
End Sub

Sub ClearScreen()
    For x = 0 To 15
        OutputDataRed(x) = 0
        OutputDataGreen(x) = 0
        OutputDataBlue(x) = 0
    Next
End Sub 

' Start Of Program
TRISB = %00000000
TRISA = %00111111                   
TRISC = %00100000
AnimationDelay = 10

' Main Loop
While True() 
    MakeBoxes
    DrawGraphics 
Wend                                 


